/***************************************************
This is an ECMAScript object file that contains 
the resources for the digit.vxml subdialog.

(C) COPYRIGHT International Business Machines Corp. 2001,2003

This program may be used, executed, copied, modified and
distributed without royalty for the purpose of developing,
using, marketing, or distributing.
****************************************************/

function Digit() {

 /*
  *The following are default values for subdialog specific parameters
  *
  */ 
  this.paramPromptQuestion = 'What are the digits?';
  this.paramStrLength = 0;


 /*
  *The following are subdialog specific error messages
  *
  *Please Note: the error message "errPromptLength" allows you to dynamically prompt users
  *             with the exact amount of digits required.  The "%1" placeholder is used 
  *             to represent the length.  If you decide NOT to use the "%1" placeholder, your
  *             message will be read back normally.
  */
  this.errPromptLength = 'You must say exactly, %1, digits.  Please try again.';


 /*
  *The following are default event prompts
  *
  */
  this.noMatch1 = 'Please say one or more digits. If you do not have the required information, say skip.';
  this.noMatch2 = 'You must say one or more digits. If you do not have the required information, say skip.';
  this.noInput1 = 'Please say one or more digits. If you do not have the required information, say skip.';
  this.noInput2 = 'Can not hear you.  The connection might be bad.  Please hang up and call again.';
  this.help1 = 'Please say one or more digits. If you do not have the required information, say skip.';
  this.help2 = 'You must say one or more digits. If you do not have the required information, say skip.';;
  this.error = 'An error has occurred in this application.  Please call back later.';


 /*
  *The following are error handling messages, if parameters get passed incorrectly.
  *These messages are for developers, while developing their voice application.  These messages
  *should never be heard by users.
  *
  */
  this.errHandStrLength = 'Exiting application due to incorrect passing of the digit subdialog parameter, String Length.';
 
  //add method the the javascript object
  this.isPosIntOrZero = isPosIntOrZero;
  this.checkStrLen = checkStrLen;
  this.substitute = substitute;
}

function isPosIntOrZero(str) {
  str = new String(str);
  var num = parseInt(str);
  var newStr = new String(num);

  if(num < 0 ||  str.length != newStr.length) {
    return false;
  } else { 
    return true; 
  }
}

function checkStrLen(str, len) {
  if(str.length == len) { 
    return true;
  } else {
    return false; 
  }
}

function substitute(str, substr, replstr){
  var index = str.indexOf(substr);
  var newString;

  if(index == -1){
    return str;
  }

  newString = str.substring(0, index) + replstr + str.substring(index + substr.length);
  return newString;
}

