/***************************************************
This is an ECMA script object file that contains 
the resources for the expirationdate.vxml subdialog.

(C) COPYRIGHT International Business Machines Corp. 2001,2003

This program may be used, executed, copied, modified and
distributed without royalty for the purpose of developing,
using, marketing, or distributing.
****************************************************/

function ExpirationDate() {

 /*
  *The following are default values for subdialog specific parameters
  *
  */
  this.paramPromptQuestion = 'Expiration date?';


 /*
  *The following are subdialog specific error messages
  *
  */
  this.errPromptCheckFebDay = 'The year specified is not a leap year.  Please try again.';


 /*
  *The following are default event prompts for expiration date 
  *
  */
  this.exDateNoMatch1 = 'Please state the month and year for the expiration date. '
                      + 'If you do not have the required information, say skip.';
  this.exDateNoMatch2 = 'You must state an expiration date, starting with the month first, '
                      + 'such as zero one zero two or January two thousand two. '
                      + 'The year must be between two thousand and two thousand eighty nine. '
                      + 'If you do not have the required information, say skip.';
  this.exDateNoInput1 = 'Please state the month and year for the expiration date. '
                      + 'If you do not have the required information, say skip.';
  this.exDateNoInput2 = 'Can not hear you.  The connection might be bad.  Please hang up and call again.';
  this.exDateHelp1 = 'Please state the month and year for the expiration date. '
                   + 'If you do not have the required information, say skip.';
  this.exDateHelp2 = 'You must state an expiration date, starting with the month first, '
                   + 'such as zero one zero two or January two thousand two. '
                   + 'The year must be between two thousand and two thousand eighty nine. '
                   + 'If you do not have the required information, say skip.';


 /*
  * The following are default subdialog specific prompts for Two Zero confirmation
  *
  *Please Note: the prompt 'promptTwoZeroConfirm' allows you to dynamically 
  *             prompt users with the characters from initial character input.  The '%1' placeholder is  
  *             used to represent the characters.  If you decide NOT to use the '%1' placeholder, your
  *             message will be read back normally.
  *
  */
  this.promptTwoZeroConfirm = 'Did you mean: %1?';


 /*
  * The following are default event prompts for Two Zero confirmation
  *
  */
  this.twoZeroNoMatch1 = 'Was that a yes?';
  this.twoZeroNoMatch2 = 'You must say yes or no.';
  this.twoZeroNoInput1 = 'Please say yes or no.';
  this.twoZeroNoInput2 = 'Can not hear you.  The connection might be bad.  Please hang up and call again.';
  this.twoZeroHelp1 = 'Please say yes or no.';
  this.twoZeroHelp2 = 'You must say yes or no.';

 /*
  *Default prompt text for the function getReturnText()
  *
  */
  this.mon1Text = 'January';
  this.mon2Text = 'February';
  this.mon3Text = 'March';
  this.mon4Text = 'April';
  this.mon5Text = 'May';
  this.mon6Text = 'June';
  this.mon7Text = 'July';
  this.mon8Text = 'August';
  this.mon9Text = 'September';
  this.mon10Text = 'October';
  this.mon11Text = 'November';
  this.mon12Text = 'December';

  this.day1Text = 'First';
  this.day2Text = 'Second';
  this.day3Text = 'Third';
  this.day4Text = 'Fourth';
  this.day5Text = 'Fifth';
  this.day6Text = 'Sixth';
  this.day7Text = 'Seventh';
  this.day8Text = 'Eighth';
  this.day9Text = 'Ninth';
  this.day10Text = 'Tenth';         
  this.day11Text = 'Eleventh';
  this.day12Text = 'Twelfth';
  this.day13Text = 'Thirteenth';
  this.day14Text = 'Fourteenth';
  this.day15Text = 'Fifteenth';
  this.day16Text = 'Sixteenth';
  this.day17Text = 'Seventeenth';
  this.day18Text = 'Eighteenth';
  this.day19Text = 'Nineteenth';
  this.day20Text = 'Twentieth';
  this.day21Text = 'Twenty First';
  this.day22Text = 'Twenty Second';
  this.day23Text = 'Twenty Third';
  this.day24Text = 'Twenty Fourth';
  this.day25Text = 'Twenty Fifth';
  this.day26Text = 'Twenty Sixth';
  this.day27Text = 'Twenty Seventh';
  this.day28Text = 'Twenty Eighth';
  this.day29Text = 'Twenty Ninth';
  this.day30Text = 'Thirtieth';
  this.day31Text = 'Thirty First';


 /*
  *The following is the default error event prompt for expiration date
  *
  */
  this.error = 'An error has occurred in this application.  Please call back later.';

  //add method the the javascript object
  this.isFullDate = isFullDate;
  this.isFebDayRight = isFebDayRight;
  this.getYear = getYear;
  this.getMonth = getMonth;
  this.getDay = getDay;
  this.makeMonth = makeMonth;
  this.makeDay = makeDay;
  this.isLeapYear = isLeapYear;
  this.isTwoZeroCase = isTwoZeroCase;
  this.substitute = substitute;
  this.addTwenty = addTwenty;
  this.getReturnText = getReturnText;
}

function isFullDate(strDate){
   strDate = new String(strDate);
   if(strDate.charAt(0) == "?" || strDate.charAt(4) == "?" || strDate.charAt(6) == "?"){
       return false;
   }else{
       return true;
   }
}

function isFebDayRight(strDate){
   if(this.getMonth(strDate) != 2){
  return true;
   }else if(this.isLeapYear(this.getYear(strDate)) == false && this.getDay(strDate) > 28){
      return false;
   }else{
      return true;
   }
}

function getYear(str){
   str = new String(str);
   var year = str.slice(0,4);
   var year_num = new Number(year);
   return year_num; 
}

function getMonth(str){
   str = new String(str);
   var month = str.slice(4,6);
   var month_num = new Number(month);
   return month_num; 
}

function getDay(str){                  
   str = new String(str);                  
   var day = str.slice(6,8);
   var day_num = new Number(day);               
   return day_num;    
}

function makeMonth(month){
  if(month == 1) return this.mon1Text;
 
  if(month == 2) return this.mon2Text;

  if(month == 3) return this.mon3Text;

  if(month == 4) return this.mon4Text;

  if(month == 5) return this.mon5Text;

  if(month == 6) return this.mon6Text;

  if(month == 7) return this.mon7Text;

  if(month == 8) return this.mon8Text;

  if(month == 9) return this.mon9Text;

  if(month == 10) return this.mon10Text;

  if(month == 11) return this.mon11Text;

  if(month == 12) return this.mon12Text;

  return "undefined";
}

function makeDay(day){
   if(day == 1) return this.day1Text;

   if(day == 2) return this.day2Text;

   if(day == 3) return this.day3Text;

   if(day == 4) return this.day4Text;

   if(day == 5) return this.day5Text;

   if(day == 6) return this.day6Text;

   if(day == 7) return this.day7Text;

   if(day == 8) return this.day8Text;

   if(day == 9) return this.day9Text;

   if(day == 10) return this.day10Text;         

   if(day == 11) return this.day11Text;

   if(day == 12) return this.day12Text;

   if(day == 13) return this.day13Text;

   if(day == 14) return this.day14Text;

   if(day == 15) return this.day15Text;

   if(day == 16) return this.day16Text;

   if(day == 17) return this.day17Text;

   if(day == 18) return this.day18Text;

   if(day == 19) return this.day19Text;

   if(day == 20) return this.day20Text;

   if(day == 21) return this.day21Text;

   if(day == 22) return this.day22Text;

   if(day == 23) return this.day23Text;

   if(day == 24) return this.day24Text;

   if(day == 25) return this.day25Text;

   if(day == 26) return this.day26Text;

   if(day == 27) return this.day27Text;

   if(day == 28) return this.day28Text;

   if(day == 29) return this.day29Text;

   if(day == 30) return this.day30Text;

   if(day == 31) return this.day31Text;

   return "undefined";
}

function isLeapYear(year){
   year = new String(year);
   var num = parseInt(year);
   var newStrYear = new String(num);

   if(newStrYear.length != 4){
      return "undefined";
   }

   var year_num = new Number(newStrYear);

   if(year_num % 4 != 0){
      return false;
   }else if(year_num % 400 == 0){
      return true;
   }else if(year_num % 100 == 0){
      return false;
   }else{
      return true;
   }
}

function isTwoZeroCase(strValue, strUtterance) {
  strValue = new String(strValue);
  strUtterance = new String(strUtterance);

  if(strValue.charAt(6) != "?" || strValue.charAt(0) !=2) {
    return false;
  }else if(strUtterance.indexOf("two zero") > 0 || strUtterance.indexOf("two oh") > 0 
           || strUtterance.indexOf("two nil") > 0 || strUtterance.indexOf("two null") > 0) {
    var spaceIndex;
    if(strUtterance.indexOf("two zero") > 0) {
      spaceIndex = strUtterance.indexOf("two zero") + 8;
    }else if(strUtterance.indexOf("two oh") > 0) {
      spaceIndex = strUtterance.indexOf("two oh") + 6;
    }else if(strUtterance.indexOf("two nil") > 0) {
      spaceIndex = strUtterance.indexOf("two nil") + 7;
    }else {
      spaceIndex = strUtterance.indexOf("two null") + 8;
    }

    if(spaceIndex == strUtterance.length) {
      return false;
    }  
    
    spaceIndex = strUtterance.indexOf(" ", spaceIndex + 1);

    if(spaceIndex == -1) {
      return false;
    } else {
        return true;
    }             
  }else {
    return false;
  }
}

function substitute(str, substr, replstr){
  var index = str.indexOf(substr);
  var newString;

  if(index == -1){
    return str;
  }

  newString = str.substring(0, index) + replstr + str.substring(index + substr.length);
  return newString;
}

function addTwenty(str) {
  str = new String(str);
  var newStr;

  newStr = str.slice(0,6) + "20";
  return newStr;
}

function getReturnText(str){
  var month = "";
  var day = "";
  var year = "";
  var newStr = "";

  if(str.charAt(0) != "?")
    year = this.getYear(str);

  if(str.charAt(4) != "?")
    month = this.makeMonth(this.getMonth(str));

  if(str.charAt(6) != "?") 
    day = this.makeDay(this.getDay(str));

  if(month.length != 0) {
    newStr = month;

    if(day.length != 0) {
      newStr = newStr + " " + day;

      if(year.length != 0) {
        newStr = newStr + ", " + year;
      }
    }
    else if(year.length != 0)  
      newStr = newStr + " " + year;
  }
  else if(year.length != 0) 
    newStr = year;

  else if(day.length != 0)
    newStr = day;

  return newStr;
}

