/***************************************************
This is an ECMAScript object file that contains 
the resources for the uspostalcode.vxml subdialog.

(C) COPYRIGHT International Business Machines Corp. 2001,2003

This program may be used, executed, copied, modified and
distributed without royalty for the purpose of developing,
using, marketing, or distributing.
****************************************************/

function USPostalCode() {

  /*
  *The following are default values for subdialog specific parameters
  *
  */
  this.paramPromptQuestion = 'U.S. postal code?';
  this.paramRequire9 = 0;

 
 /*
  *The following are subdialog specific error messages
  *
  *Please Note: the error message "errPromptLength" allows you to dynamically prompt users
  *             with the exact postal code type (5 or 9 digits).  The "%1" placeholder is used 
  *             to represent the length.  If you decide NOT to use the "%1" placeholder, your
  *             message will be read back normally.
  *
  */
  this.errPromptLength = 'You must state a %1 digit postal code.  Please try again.';
  this.err9Digits = '9';
  this.err5or9Digits = '5 or 9';


 /*
  *The following are default event prompts when 5, or optionally 9 digits, are used
  *
  */
  this.noMatch1 = 'Please state a U.S. postal code one digit at a time.  If you do not have '
                + 'the required information, say skip.';
  this.noMatch2 = 'You must state a U.S. postal code one digit at a time.  If you do not have '
                + 'the required information, say skip.';
  this.noInput1 = 'You must state a U.S. postal code one digit at a time.  If you do not have '
                + 'the required information, say skip.';
  this.noInput2 = 'Can not hear you.  The connection might be bad.  Please hang up and call again.';
  this.help1 = 'Please state a U.S. postal code one digit at a time.  If you do not have the '
             + 'required information, say skip.';
  this.help2 = 'You must state a U.S. postal code one digit at a time.  If you do not have the '
             + 'required information, say skip.';


/*
  *The following are default event prompts when 9 digits are required
  *
  */

  this.require9NoMatch1 = 'Please state a 9 digit U.S. postal code one digit at a time.  If you '
                        + 'do not have the required information, say skip.';
  this.require9NoMatch2 = 'You must state a 9 digit U.S. postal code one digit at a time.  If '
                        + 'you do not have the required information, say skip.';
  this.require9NoInput1 = 'You must state a 9 digit U.S. postal code one digit at a time.  If '
                        + 'you do not have the required information, say skip.';
  this.require9NoInput2 = 'Can not hear you.  The connection might be bad.  Please hang up and '
                        + 'call again.';
  this.require9Help1 = 'Please state a 9 digit U.S. postal code one digit at a time.  If you do '
                     + 'not have the required information, say skip.';
  this.require9Help2 = 'You must state a 9 digit U.S. postal code one digit at a time.  If you do '
                     + 'not have the required information, say skip.';
  

 /*
  *The following is the default error event prompt
  *
  */

  this.error = 'An error has occurred in this application.  Please call back later.';

 

 /*
  *The following are error handling messages, if parameters get passed incorrectly.
  *These messages are for developers, while developing their voice application.  These messages
  *should never be heard by users.
  *
  */
  this.errHandPostalCodeType = 'Exiting application due to incorrect passing of the U.S. postal code subdialog parameter, Require 9.';

  //add method the the javascript object
  this.isPosIntOrZero = isPosIntOrZero;
  this.checkStrLen = checkStrLen;
  this.substitute = substitute;

}

function isPosIntOrZero(str) {
  str = new String(str);
  var num = parseInt(str);
  var newStr = new String(num);

  if(num < 0 ||  str.length != newStr.length) {
    return false;
  } else { 
    return true; 
  }
}

function checkStrLen(str, len) {
  if(str.length == len) { 
    return true;
  } else {
    return false; 
  }
}

function substitute(str, substr, replstr){
  var index = str.indexOf(substr);
  var newString;

  if(index == -1){
    return str;
  }

  newString = str.substring(0, index) + replstr + str.substring(index + substr.length);
  return newString;
}

